
Partial Class ClientCallback
    Inherits System.Web.UI.Page
    Implements ICallbackEventHandler


    Const callbackFunction As String = _
        "function RetrieveStockQuoteFromServer() {0}" & _
          "var symbolInput = document.getElementById('{2}');" & _
          "{3};" & _
          "{1}" & _
        "function StockQuoteFromServer(result, context) {0}" & _
          "var resultTextBox = document.getElementById('{4}');" & _
          "resultTextBox.value = resultTextBox.value " & _
          "+ '\r\n' + result;" & _
       "{1} "

    Sub Page_Init(ByVal o As Object, ByVal e As EventArgs) _
                                              Handles Me.Init
        Dim callbackMethod As String = _
            String.Format(callbackFunction, "{", "}", _
                symbolTextBox.ClientID, _
                ClientScript.GetCallbackEventReference(Me, _
                    "symbolInput.value", _
                    "StockQuoteFromServer", _
                    "symbolInput.id", "null", False), _
                resultTextBox.ClientID)

        ClientScript.RegisterClientScriptBlock(Me.GetType(), "CallbackFunctions", callbackMethod, True)

    End Sub


    Protected Sub lookupSymboButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lookupSymboButton.Click
        resultTextBox.Text += String.Format( _
              "{0}The value of {1} at {2} is {3}", _
                 Environment.NewLine, symbolTextBox.Text, _
                 DateTime.Now, _
                 New Random(Environment.TickCount).Next(0, 120))

    End Sub

    Public Function RaiseCallbackEvent(ByVal eventArgument As String) As String Implements System.Web.UI.ICallbackEventHandler.RaiseCallbackEvent
        Return String.Format("The value of {0} at {1} is {2}", eventArgument, _
            DateTime.Now.ToString(), _
            New Random(Environment.TickCount).Next(0, 120))
    End Function
End Class
