<%@ Page Language="VB" AutoEventWireup="false" CodeFile="ClientCallback.aspx.vb" Inherits="ClientCallback" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        Please Enter a symbol:&nbsp;
        <asp:TextBox ID="symbolTextBox" runat="server"></asp:TextBox>&nbsp;<asp:Button
            ID="lookupSymboButton" runat="server"
            Text="Lookup (POST) " />
        <input id="lookupSymbolInput" type="button" value="Lookup (Callback)" onclick="RetrieveStockQuoteFromServer()" /><br />
        <asp:TextBox ID="resultTextBox" runat="server"
            Rows="10" TextMode="MultiLine" Width="98%"></asp:TextBox><asp:GridView
                ID="GridView1" runat="server" AutoGenerateColumns="False"
                DataKeyNames="au_id" DataSourceID="SqlDataSource1"
                EmptyDataText="There are no data records to display.">
                <Columns>
                    <asp:BoundField DataField="au_id" HeaderText="au_id"
                        ReadOnly="True" SortExpression="au_id" />
                    <asp:BoundField DataField="au_lname" HeaderText="au_lname"
                        SortExpression="au_lname" />
                    <asp:BoundField DataField="au_fname" HeaderText="au_fname"
                        SortExpression="au_fname" />
                    <asp:BoundField DataField="phone" HeaderText="phone"
                        SortExpression="phone" />
                    <asp:BoundField DataField="address" HeaderText="address"
                        SortExpression="address" />
                    <asp:BoundField DataField="city" HeaderText="city"
                        SortExpression="city" />
                    <asp:BoundField DataField="state" HeaderText="state"
                        SortExpression="state" />
                    <asp:BoundField DataField="zip" HeaderText="zip"
                        SortExpression="zip" />
                    <asp:CheckBoxField DataField="contract" HeaderText="contract"
                        SortExpression="contract" />
                </Columns>
            </asp:GridView>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server"
            ConnectionString="<%$ ConnectionStrings:PubsConnectionString1 %>"
            DeleteCommand="DELETE FROM [authors] WHERE [au_id] = @original_au_id"
            InsertCommand="INSERT INTO [authors] ([au_id], [au_lname], [au_fname], [phone], [address], [city], [state], [zip], [contract]) VALUES (@au_id, @au_lname, @au_fname, @phone, @address, @city, @state, @zip, @contract)"
            ProviderName="<%$ ConnectionStrings:PubsConnectionString1.ProviderName %>"
            SelectCommand="SELECT [au_id], [au_lname], [au_fname], [phone], [address], [city], [state], [zip], [contract] FROM [authors]"
            UpdateCommand="UPDATE [authors] SET [au_lname] = @au_lname, [au_fname] = @au_fname, [phone] = @phone, [address] = @address, [city] = @city, [state] = @state, [zip] = @zip, [contract] = @contract WHERE [au_id] = @original_au_id">
            <InsertParameters>
                <asp:Parameter Name="au_id" Type="String" />
                <asp:Parameter Name="au_lname" Type="String" />
                <asp:Parameter Name="au_fname" Type="String" />
                <asp:Parameter Name="phone" Type="String" />
                <asp:Parameter Name="address" Type="String" />
                <asp:Parameter Name="city" Type="String" />
                <asp:Parameter Name="state" Type="String" />
                <asp:Parameter Name="zip" Type="String" />
                <asp:Parameter Name="contract" Type="Boolean" />
            </InsertParameters>
            <UpdateParameters>
                <asp:Parameter Name="au_lname" Type="String" />
                <asp:Parameter Name="au_fname" Type="String" />
                <asp:Parameter Name="phone" Type="String" />
                <asp:Parameter Name="address" Type="String" />
                <asp:Parameter Name="city" Type="String" />
                <asp:Parameter Name="state" Type="String" />
                <asp:Parameter Name="zip" Type="String" />
                <asp:Parameter Name="contract" Type="Boolean" />
                <asp:Parameter Name="original_au_id" Type="String" />
            </UpdateParameters>
            <DeleteParameters>
                <asp:Parameter Name="original_au_id" Type="String" />
            </DeleteParameters>
        </asp:SqlDataSource>
    
    </div>
    </form>
</body>
</html>
